Index: protocols/bee_user.c
===================================================================
--- protocols/bee_user.c	(revision 0864a524c9fd1184874d550216beb49f6a0bef55)
+++ protocols/bee_user.c	(revision 6191263b71f7060e7d0d754db519599bbb71a802)
@@ -286,5 +286,5 @@
 
 	/* up to the protocol to set_add this if they want to use this */
-	handle = set_getstr(&ic->acc->set, "notify_handle");
+	handle = set_getstr(&ic->acc->set, "mail_notifications_handle");
 
 	if (handle != NULL) {
Index: protocols/jabber/iq.c
===================================================================
--- protocols/jabber/iq.c	(revision 0864a524c9fd1184874d550216beb49f6a0bef55)
+++ protocols/jabber/iq.c	(revision 6191263b71f7060e7d0d754db519599bbb71a802)
@@ -803,5 +803,5 @@
 	}
 
-	max = set_getint(&ic->acc->set, "gmail_notifications_limit");
+	max = set_getint(&ic->acc->set, "mail_notifications_limit");
 	c = c->children;
 
Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision 0864a524c9fd1184874d550216beb49f6a0bef55)
+++ protocols/jabber/jabber.c	(revision 6191263b71f7060e7d0d754db519599bbb71a802)
@@ -101,12 +101,12 @@
 	s = set_add(&acc->set, "xmlconsole", "false", set_eval_bool, acc);
 
-	s = set_add(&acc->set, "gmail_notifications", "false", set_eval_bool, acc);
+	s = set_add(&acc->set, "mail_notifications", "false", set_eval_bool, acc);
 	s->flags |= ACC_SET_OFFLINE_ONLY;
 
 	/* changing this is rarely needed so keeping it secret */
-	s = set_add(&acc->set, "gmail_notifications_limit", "5", set_eval_int, acc);
+	s = set_add(&acc->set, "mail_notifications_limit", "5", set_eval_int, acc);
 	s->flags |= SET_HIDDEN_DEFAULT;
 
-	s = set_add(&acc->set, "notify_handle", NULL, NULL, acc);
+	s = set_add(&acc->set, "mail_notifications_handle", NULL, NULL, acc);
 	s->flags |= ACC_SET_OFFLINE_ONLY | SET_NULL_OK;
 
@@ -268,8 +268,10 @@
 		imcb_add_buddy(ic, JABBER_XMLCONSOLE_HANDLE, NULL);
 	}
-	if (set_getbool(&acc->set, "gmail_notifications")) {
+
+	if (set_getbool(&acc->set, "mail_notifications")) {
+		/* It's gmail specific, but it checks for server support before enabling it */
 		jd->flags |= JFLAG_GMAILNOTIFY;
-		if (set_getstr(&acc->set, "notify_handle")) {
-			imcb_add_buddy(ic, set_getstr(&acc->set, "notify_handle"), NULL);
+		if (set_getstr(&acc->set, "mail_notifications_handle")) {
+			imcb_add_buddy(ic, set_getstr(&acc->set, "mail_notifications_handle"), NULL);
 		}
 	}
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision 0864a524c9fd1184874d550216beb49f6a0bef55)
+++ protocols/msn/msn.c	(revision 6191263b71f7060e7d0d754db519599bbb71a802)
@@ -49,5 +49,5 @@
 	s->flags |= ACC_SET_OFFLINE_ONLY;
 
-	s = set_add(&acc->set, "notify_handle", NULL, NULL, acc);
+	s = set_add(&acc->set, "mail_notifications_handle", NULL, NULL, acc);
 	s->flags |= ACC_SET_OFFLINE_ONLY | SET_NULL_OK;
 
@@ -87,6 +87,6 @@
 	               set_getint(&ic->acc->set, "port"));
 
-	if (set_getbool(&acc->set, "mail_notifications") && set_getstr(&acc->set, "notify_handle")) {
-		imcb_add_buddy(ic, set_getstr(&acc->set, "notify_handle"), NULL);
+	if (set_getbool(&acc->set, "mail_notifications") && set_getstr(&acc->set, "mail_notifications_handle")) {
+		imcb_add_buddy(ic, set_getstr(&acc->set, "mail_notifications_handle"), NULL);
 	}
 }
Index: protocols/purple/purple.c
===================================================================
--- protocols/purple/purple.c	(revision 0864a524c9fd1184874d550216beb49f6a0bef55)
+++ protocols/purple/purple.c	(revision 6191263b71f7060e7d0d754db519599bbb71a802)
@@ -239,5 +239,5 @@
 		s->flags |= ACC_SET_OFFLINE_ONLY;
 
-		s = set_add(&acc->set, "notify_handle", NULL, NULL, acc);
+		s = set_add(&acc->set, "mail_notifications_handle", NULL, NULL, acc);
 		s->flags |= ACC_SET_OFFLINE_ONLY | SET_NULL_OK;
 	}
@@ -336,6 +336,6 @@
 	purple_account_set_enabled(pd->account, "BitlBee", TRUE);
 
-	if (set_getbool(&acc->set, "mail_notifications") && set_getstr(&acc->set, "notify_handle")) {
-		imcb_add_buddy(ic, set_getstr(&acc->set, "notify_handle"), NULL);
+	if (set_getbool(&acc->set, "mail_notifications") && set_getstr(&acc->set, "mail_notifications_handle")) {
+		imcb_add_buddy(ic, set_getstr(&acc->set, "mail_notifications_handle"), NULL);
 	}
 }
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision 0864a524c9fd1184874d550216beb49f6a0bef55)
+++ protocols/yahoo/yahoo.c	(revision 6191263b71f7060e7d0d754db519599bbb71a802)
@@ -128,5 +128,5 @@
 	s->flags |= ACC_SET_OFFLINE_ONLY;
 
-	s = set_add(&acc->set, "notify_handle", NULL, NULL, acc);
+	s = set_add(&acc->set, "mail_notifications_handle", NULL, NULL, acc);
 	s->flags |= ACC_SET_OFFLINE_ONLY | SET_NULL_OK;
 
@@ -152,6 +152,6 @@
 	yahoo_login(yd->y2_id, yd->current_status);
 
-	if (set_getbool(&acc->set, "mail_notifications") && set_getstr(&acc->set, "notify_handle")) {
-		imcb_add_buddy(ic, set_getstr(&acc->set, "notify_handle"), NULL);
+	if (set_getbool(&acc->set, "mail_notifications") && set_getstr(&acc->set, "mail_notifications_handle")) {
+		imcb_add_buddy(ic, set_getstr(&acc->set, "mail_notifications_handle"), NULL);
 	}
 }