Index: Makefile
===================================================================
--- Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -163,17 +163,17 @@
 
 $(subdirs):
-	@$(MAKE) -C $@ $(MAKECMDGOALS)
+	$(MAKE) -C $@ $(MAKECMDGOALS)
 
 $(OTR_PI): %.so: $(_SRCDIR_)%.c
 	@echo '*' Building plugin $@
-	@$(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) $< -o $@ $(OTRFLAGS)
+	$(VERBOSE) $(CC) $(CFLAGS) -fPIC -shared $(LDFLAGS) $< -o $@ $(OTRFLAGS)
 
 $(SKYPE_PI): $(_SRCDIR_)protocols/skype/skype.c
 	@echo '*' Building plugin skype
-	@$(CC) $(CFLAGS) $(LDFLAGS) $(SKYPEFLAGS) $< -o $@
+	$(VERBOSE) $(CC) $(CFLAGS) $(LDFLAGS) $(SKYPEFLAGS) $< -o $@
 
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 $(objects): Makefile Makefile.settings config.h
@@ -181,8 +181,8 @@
 $(OUTFILE): $(objects) $(subdirs)
 	@echo '*' Linking $(OUTFILE)
-	@$(CC) $(objects) $(subdirobjs) -o $(OUTFILE) $(LDFLAGS_BITLBEE) $(LDFLAGS) $(EFLAGS)
+	$(VERBOSE) $(CC) $(objects) $(subdirobjs) -o $(OUTFILE) $(LDFLAGS_BITLBEE) $(LDFLAGS) $(EFLAGS)
 ifneq ($(firstword $(STRIP)), \#)
 	@echo '*' Stripping $(OUTFILE)
-	@-$(STRIP) $(OUTFILE)
+	$(VERBOSE) -$(STRIP) $(OUTFILE)
 endif
 
Index: configure
===================================================================
--- configure	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ configure	(revision 051506399e1455d88f6179010129308c754be936)
@@ -39,4 +39,5 @@
 purple=0
 
+verbose=0
 doc=1
 debug=0
@@ -125,4 +126,6 @@
 --pidfile=...						$pidfile
 --config=...						$config
+
+--verbose=0/1	Disable/enable verbose build		$verbose
 
 --msn=0/1	Disable/enable MSN part			$msn
@@ -282,4 +285,23 @@
 	debug=1
 fi
+
+if [ "$verbose" = "0" ]; then
+	echo 'VERBOSE=@' >> Makefile.settings
+else
+	echo 'VERBOSE=' >> Makefile.settings
+fi
+
+cat <<EOF >>Makefile.settings
+
+# Enable/disable output verbosity
+ifdef V
+ifeq (\$(V),1)
+	VERBOSE=
+else
+	VERBOSE=@
+endif
+endif
+
+EOF
 
 if [ "$debug" = "1" ]; then
Index: ipc.c
===================================================================
--- ipc.c	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ ipc.c	(revision 051506399e1455d88f6179010129308c754be936)
@@ -898,5 +898,5 @@
 	strcpy(un_addr.sun_path, IPCSOCKET);
 
-	serversock = socket(AF_UNIX, SOCK_STREAM, PF_UNIX);
+	serversock = socket(AF_UNIX, SOCK_STREAM, 0);
 
 	if (serversock == -1) {
Index: lib/Makefile
===================================================================
--- lib/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ lib/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -36,5 +36,5 @@
 lib.o: $(objects) $(subdirs)
 	@echo '*' Linking lib.o
-	@$(LD) $(LFLAGS) $(objects) -o lib.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o lib.o
 
 $(objects): ../Makefile.settings Makefile
@@ -42,5 +42,5 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 -include .depend/*.d
Index: protocols/Makefile
===================================================================
--- protocols/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ protocols/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -43,5 +43,5 @@
 
 $(subdirs):
-	@$(MAKE) -C $@ $(MAKECMDGOALS)
+	$(MAKE) -C $@ $(MAKECMDGOALS)
 
 ### MAIN PROGRAM
@@ -49,5 +49,5 @@
 protocols.o: $(objects) $(subdirs)
 	@echo '*' Linking protocols.o
-	@$(LD) $(LFLAGS) $(objects) $(subdirobjs) -o protocols.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) $(subdirobjs) -o protocols.o
 
 $(objects): ../Makefile.settings Makefile
@@ -55,5 +55,5 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 -include .depend/*.d
Index: protocols/jabber/Makefile
===================================================================
--- protocols/jabber/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ protocols/jabber/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -38,9 +38,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 jabber_mod.o: $(objects)
 	@echo '*' Linking jabber_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o jabber_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o jabber_mod.o
 
 -include .depend/*.d
Index: protocols/msn/Makefile
===================================================================
--- protocols/msn/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ protocols/msn/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -38,9 +38,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 msn_mod.o: $(objects)
 	@echo '*' Linking msn_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o msn_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o msn_mod.o
 
 -include .depend/*.d
Index: protocols/oscar/Makefile
===================================================================
--- protocols/oscar/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ protocols/oscar/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -39,9 +39,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 oscar_mod.o: $(objects)
 	@echo '*' Linking oscar_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o oscar_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o oscar_mod.o
 
 -include .depend/*.d
Index: protocols/purple/Makefile
===================================================================
--- protocols/purple/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ protocols/purple/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -39,9 +39,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 purple_mod.o: $(objects)
 	@echo '*' Linking purple_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o purple_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o purple_mod.o
 
 -include .depend/*.d
Index: protocols/twitter/Makefile
===================================================================
--- protocols/twitter/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ protocols/twitter/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -38,9 +38,9 @@
 $(objects): %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $(CFLAGS_BITLBEE) $< -o $@
 
 twitter_mod.o: $(objects)
 	@echo '*' Linking twitter_mod.o
-	@$(LD) $(LFLAGS) $(objects) -o twitter_mod.o
+	$(VERBOSE) $(LD) $(LFLAGS) $(objects) -o twitter_mod.o
 	
 -include .depend/*.d
Index: tests/Makefile
===================================================================
--- tests/Makefile	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ tests/Makefile	(revision 051506399e1455d88f6179010129308c754be936)
@@ -21,7 +21,7 @@
 check: $(test_objs) $(addprefix ../, $(main_objs)) ../protocols/protocols.o ../lib/lib.o
 	@echo '*' Linking $@
-	@$(CC) $(CFLAGS) -o $@ $^ $(LFLAGS) $(EFLAGS)
+	$(VERBOSE) $(CC) $(CFLAGS) -o $@ $^ $(LFLAGS) $(EFLAGS)
 
 %.o: $(_SRCDIR_)%.c
 	@echo '*' Compiling $<
-	@$(CC) -c $(CFLAGS) $< -o $@
+	$(VERBOSE) $(CC) -c $(CFLAGS) $< -o $@
Index: tests/check.c
===================================================================
--- tests/check.c	(revision b0979452e9d42896b8f6fdc0da76dc0c79651b62)
+++ tests/check.c	(revision 051506399e1455d88f6179010129308c754be936)
@@ -14,5 +14,5 @@
 	int sock[2];
 
-	if (socketpair(AF_UNIX, SOCK_STREAM, PF_UNIX, sock) < 0) {
+	if (socketpair(AF_UNIX, SOCK_STREAM, 0, sock) < 0) {
 		perror("socketpair");
 		return FALSE;